<?xml version="1.0" encoding="utf-8"?>
<!-- Copyright (c) 2019 - Present PIT Solutions AG. (<https://www.pitsolutions.ch/>) -->
<!-- See LICENSE file for full copyright and licensing details. -->
<!-- License URL : https://www.webshopextension.com/en/licence-agreement/ -->
<odoo>

    <record id="acquirer_form_saferpay" model="ir.ui.view">
        <field name="name">payment.acquirer.form.inherit</field>
        <field name="model">payment.acquirer</field>
        <field name="inherit_id" ref="payment.acquirer_form" />
        <field name="arch" type="xml">          
            <xpath expr="//field[@name='module_id']" position="before">
                <div class="oe_button_box" name="button_box">
                    <button class="oe_stat_button" type="object"
                        name="action_view_saferpay_acquirer_logging"
                        groups="base.group_user"
                        attrs="{'invisible': [('provider', '!=', 'saferpay')]}"
                        icon="fa-history">
                        <div class="o_stat_info o_field_widget">
                            <span class="o_stat_text">Saferpay Logging</span>
                        </div>
                    </button>
                    <button name="toggle_license_switch"
                        class="oe_stat_button"
                        type="object" icon="fa-adjust"
                        attrs="{'invisible': [('provider', '!=', 'saferpay')]}"
                        groups="base.group_user"
                        >
                        <field name="license_type" readonly="1" />
                    </button>
                </div>
            </xpath>
            <xpath expr="//field[@name='save_token']" position="attributes">
                <attribute name="attrs">
                    {'invisible': ['&amp;', ('provider', '!=', 'saferpay'), '|', ('token_implemented', '=', False), ('payment_flow', '=', 's2s')]}
                </attribute>
            </xpath>
            <xpath expr="//field[@name='payment_icon_ids']" position="attributes">
                <attribute name="attrs">
                    {'required': [('provider', '=', 'saferpay')]}
                </attribute>
                <attribute name="context">
                    {'provider': provider}
                </attribute>
            </xpath>
            <xpath expr='//group[@name="acquirer"]' position='after'>
                <group attrs="{'invisible': [('provider', '!=', 'saferpay')]}">
                    <field name="saferpay_config_id" />
                    <field name="safer_code" groups="base.group_no_one"/>
                </group>
            </xpath>
            <xpath expr="//field[@name='registration_view_template_id']" position='attributes'>
                <attribute name='attrs'>{'required': [('provider', '=', 'saferpay'), '|','|',('payment_flow','=','s2s'), ('save_token', 'in', ['ask','always']), '&amp;', ('is_support_refund', '=', True),('support_refund_type', 'in', ['direct','both'])]}</attribute>
            </xpath>
            <xpath expr="//group[@name='acquirer_config']" position='after'>
                <group string="Saferpay Configurations" attrs="{'invisible': [('provider', '!=', 'saferpay')]}">
                    
                    <group>
                        <h3 style="color: #7C7BAD">Payment Form</h3>
                         <field name="multipart_capture" attrs="{'invisible': ['|', ('provider', '!=', 'saferpay'),('capture_manually', '=', False)]}"/>
                        <field name="need_order_limit" attrs="{'invisible': [('provider', '!=', 'saferpay')]}"/>
                        <field name='min_order_total'
                            attrs="{'invisible': ['|', ('need_order_limit', '!=', True), ('provider', '!=', 'saferpay')]}" />
                        <field name='max_order_total'
                            attrs="{'invisible': ['|', ('need_order_limit', '!=', True), ('provider', '!=', 'saferpay')]}" />
                        <field name='customer_address'
                            attrs="{'invisible': ['|', ('provider', '!=', 'saferpay'),('safer_code','=', 'EPRZELEWY')],
                            'required': [('provider', '=', 'saferpay')]}" />
                        <field name='preauth'
                            attrs="{'invisible': ['|',('provider', '!=', 'saferpay'), ('safer_code', 'not in', ['VISA','MAESTRO','MASTERCARD'])],
                            'required': [('provider', '=', 'saferpay'), ('safer_code', 'in', ['VISA','MAESTRO','MASTERCARD'])]}" />
                        <field name='special_customer_address' 
                            attrs="{'invisible': ['|', ('provider', '!=', 'saferpay'),('safer_code','!=', 'EPRZELEWY')],
                            'required': [('provider', '=', 'saferpay'),('safer_code','=', 'EPRZELEWY')]}"
                            />
                         <field name='is_wallet' attrs="{'invisible': ['|', ('provider', '!=', 'saferpay'), ('safer_code', '!=', 'MASTERPASS')]}"/>
                         <field name='is_applepay' attrs="{'invisible': ['|', ('provider', '!=', 'saferpay'), ('safer_code', '!=', 'APPLEPAY')]}"/>
                        <field name='supports_notify_url' attrs="{'invisible': [('provider', '!=', 'saferpay')]}"/>
                        <field name='cust_confirm_mail' attrs="{'invisible': [('provider', '!=', 'saferpay')]}"/>
                        <field name='interface_type' attrs="{'invisible': ['|', ('provider', '!=', 'saferpay'), ('payment_flow', '=', 's2s')], 'required': [('provider', '=', 'saferpay'), ('payment_flow', '!=', 's2s')]}" readonly="1"/>
                        <field name='saferpay_fields_form_type' attrs="{'invisible': ['|', ('interface_type', '!=', 'saferpay_fields'), ('provider', '!=', 'saferpay')], 'required': [('provider', '=', 'saferpay'), ('interface_type', '=', 'saferpay_fields')]}"/>
                         <field name="register_payment_type"
                                attrs="{'invisible': ['|', ('save_token', 'not in', ['ask', 'always']), ('provider', '!=', 'saferpay')], 'required': [('save_token', 'in', ['ask', 'always']), ('provider', '=', 'saferpay')]}" /> 
                    </group>
                    
                    <group>
                        <h3 style="color: #7C7BAD">Availability</h3>
                        <field name='currency_ids' widget="many2many_tags"
                        attrs="{'invisible': [('provider', '!=', 'saferpay')]}"/>
                        <h3 style="color: #7C7BAD" attrs="{'invisible': ['|', ('provider', '!=', 'saferpay'), ('safer_code', '!=', 'IDEAL')]}" >Only for iDeal</h3>
                    	<field name='issuer_id' attrs="{'invisible': ['|', ('provider', '!=', 'saferpay'), ('safer_code', '!=', 'IDEAL')], 'required': [('safer_code', '=', 'IDEAL')]}"/>
                    </group>
                    
                    <group attrs="{'invisible': ['|',('provider', '!=', 'saferpay'),('license_type','!=', 'business')]}">
                        <h3 style="color: #7C7BAD">Refund</h3>
                        <field name='is_support_refund' attrs="{'invisible': ['|',('provider', '!=', 'saferpay'),('license_type','!=', 'business')]}"/>
                        <field name='support_refund_type'
                            attrs="{'invisible': ['|', '|', ('is_support_refund', '!=', True), ('provider', '!=', 'saferpay'),('license_type','!=', 'business')], 'required': [('is_support_refund', '=', True),('license_type','=', 'business')]}" />
                    </group>
                    <group>
                    </group>
                </group>
                <label for="support_refund_type" string="" />
                <label for="support_refund_type" style="color:Red;" string="Warning: Direct Refund should be supported for PCI certified merchants!" attrs="{'invisible': ['|', ('is_support_refund','=', False),('support_refund_type', 'not in', ['direct','both'])]}"/>
            </xpath> 
        </field>
    </record>
      
    <record id="transaction_form_inherit_payment_saferpay" model="ir.ui.view">
        <field name="name">payment.transaction.form.inherit</field>
        <field name="model">payment.transaction</field>
        <field name="inherit_id" ref="payment.transaction_form" />
        <field name="arch" type="xml">
            <xpath expr="//div[@name='button_box']" position="inside">
                <button class="oe_stat_button" name="%(payment_saferpay.action_saferpay_acquirer_log)d"
                    type="action"
                    groups="base.group_user"
                    attrs="{'invisible': [('provider', '!=', 'saferpay')]}"
                    context="{'search_default_txn_ref': reference}"
                    icon="fa-history">
                    <div class="o_stat_info o_field_widget">
                        <span class="o_stat_text">Saferpay Logging</span>
                    </div>
                </button>
                <button name="action_view_multipart_captures" type="object"
                                    class="oe_stat_button" icon="fa-money"
                                    attrs="{'invisible': [('multipart_capture_ids_nbr', '=', 0)]}">
                    <field name="multipart_capture_ids_nbr" widget="statinfo" string="Multipart Capture(s)"/>
                    <field name="multipart_capture_ids_done_nbr" invisible="1"/>
                </button>
            </xpath>
            <xpath expr='//group[1]' position='after'>
                <group string="Saferpay Info" name="saferpay" attrs="{'invisible': [('provider', '!=', 'saferpay')]}">
                    <group>
                        <field name="saferpay_state" />
                        <field name="saferpay_token" invisible="1" />
                        <field name="saferpay_req_token"/>
                        <field name="saferpay_txn_ref"/>
                        <field name="saferpay_captureid" attrs="{'invisible': [('saferpay_captureid', '=', False)]}"/>
                        <field name="liability_shift" invisible="0"/>
                    </group>
                    <group>
                        <field name="liability"/>
                        <field name="three_ds" attrs="{'invisible': [('three_ds', '=', False)]}"/>
                        <field name="liability_entity_shift" attrs="{'invisible': [('liability_entity_shift', '=', False)]}"/>
                        <field name="authenticated" attrs="{'invisible': [('authenticated', '=', False)]}"/>
                        <field name="error_on_saferpay" attrs="{'invisible': [('error_on_saferpay', '=', False)]}"/>
                        <field name="captured_amount" attrs="{'invisible': [('multipart_capture_ids_done_nbr', '=', 0)]}"/>
                        <field name="multipart_capture" invisible="1"/>
                        <field name="invoke_notify_url" invisible="1"/>
                        <field name="auth_result" attrs="{'invisible': [('auth_result', '=', False)]}"/>
                        <field name="auth_message" attrs="{'invisible': [('auth_message', '=', False)]}"/>
                    </group>
                </group>
            </xpath>
            <xpath expr='//form' position='inside'>
                <div class="oe_chatter">
                    <field name="message_follower_ids" widget="mail_followers"/>
                    <field name="message_ids" widget="mail_thread"/>
                </div>
            </xpath>
            <xpath expr='//button[@name="action_capture"]' position='replace'>
                <button type="object" name="action_capture" string="Capture Transaction"
                    class="oe_highlight" attrs="{'invisible': ['|', ('state', '!=', 'authorized'), ('multipart_capture_ids_done_nbr', '>', 0)]}"/>
                <button name="saferpay_multipart_capture"
                    string="Multipart Capture" class="oe_highlight"
                    attrs="{'invisible': ['|', '|', ('state', '!=', 'authorized'), ('provider', '!=', 'saferpay'),('multipart_capture','!=', True)]}" type="object"/>
                <button name="saferpay_s2s_capture_transaction" string="Capture" class="oe_highlight" attrs="{'invisible': ['|', ('state', '!=', 'pending'), ('provider', '!=', 'saferpay')]}" type="object"/>
                <button name="force_check_safepay_txn_status" string="Force to Check Status" attrs="{'invisible': ['|', '|', ('state', 'not in', ['pending', 'authorized']), ('provider', '!=', 'saferpay'), ('error_on_saferpay', '=', False)]}" type="object"/>
            </xpath>
        </field>
    </record>
    
    <record id="payment_token_form_view_inherit_payment_saferpay" model="ir.ui.view">
        <field name="name">payment.token.form.inherit</field>
        <field name="model">payment.token</field>
        <field name="inherit_id" ref="payment.payment_token_form_view" />
        <field name="arch" type="xml">
            <field name="partner_id" position="after">
                <field name="request_id" attrs="{'invisible': [('request_id', '=', False)]}" />
                <field name="saferpay_token" attrs="{'invisible': [('saferpay_token', '=', False)]}" />
            </field>
            <field name="acquirer_ref" position="after">
                <field name="is_authenticated" invisible="1" />
                <field name="auth_result" attrs="{'invisible': [('auth_result', '=', False)]}" />
            </field>
        </field>
    </record>
    
    <record id="payment_icon_form_view_view_inherit_payment_saferpay" model="ir.ui.view">
        <field name="name">payment.icon.form.inherit</field>
        <field name="model">payment.icon</field>
        <field name="inherit_id" ref="payment.payment_icon_form_view" />
        <field name="arch" type="xml">
            <xpath expr="//page" position="after">
            	<page string="Saferpay Configurations" name="saferpay_config" attrs="{'invisible': [('is_saferpay', '=', False)]}">
	            	<group>
	            		<group>
	            			<field name="saferpay_code" attrs="{'invisible': [('is_saferpay', '=', False)],
		                									'required': [('is_saferpay', '=', True)]}" />
		                	<field name="is_saferpay"/>
	            		</group>
	            		<group>
	            			<field name='currency_ids' widget="many2many_tags"
	                        domain="[('saferpay_payment_icons', '=', id)]" attrs="{'invisible': [('is_saferpay', '=', False)]}"
	                        options="{'no_create': True, 'no_create_edit': True, 'no_quick_create': True, 'no_open': True}" />
	            			<field name="support_saferpay_fields" attrs="{'invisible': [('is_saferpay', '=', False)]}" />
	            		</group>
	                </group>
                </page>
            </xpath>
        </field>
    </record>
    
    <record id="view_currency_form_inherit_payment_saferpay" model="ir.ui.view">
        <field name="name">res.currency.form.inherit</field>
        <field name="model">res.currency</field>
        <field name="inherit_id" ref="base.view_currency_form" />
        <field name="arch" type="xml">
            <field name="rate" position="after">
                <field name="saferpay_payment_icons" groups="base.group_no_one" />
            </field>
        </field>
    </record>

</odoo>
